package cn.com.taiji.esshipservice.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;

/**
 * <p>
 * 崖州中心渔港北斗信息表
 * </p>
 *
 * @author linhaiy
 * @since 2022-08-18
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("yz_port_ship")
public class YzPortShip implements Serializable {

    private static final long serialVersionUID = 1L;

    //主键
    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    //船舶编号
    @TableField("ship_name")
    private String shipName;

    //北斗ID
    @TableField("devide_no")
    private Long devideNo;

//    //轨迹发生时间
//    @TableField("location_time")
//    private String locationTime;


}
