package cn.com.taiji.esshipservice.domain;

import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.ToString;

import java.io.Serializable;

/**
 * @author chenfangchao
 * @title: ShipTrackHistoryDTO
 * @projectName ax_ship_track_es_service
 * @description: TODO 船舶轨迹模型
 * @date 2022/8/7 2:15 AM
 */
@Data
@ToString
@TableName("es_ship_track_record")
public class ShipTrackHistoryDTO implements Serializable {

    private static final long serialVersionUID = -5072462180309665596L;

    private Long id;

    //北斗号
    private String beidouId;

    //位置轨迹
    private String location;

    //位置轨迹时间
    private String locationTime;
}
