package cn.com.taiji.esshipservice.domain;

import lombok.Data;
import org.elasticsearch.common.geo.GeoPoint;

@Data
public class TestQuery {

    /**
     * 索引名
     */
    private String name;

    /**
     * 上
     */
    private GeoPoint topLeft;

    /**
     * 下
     */
    private GeoPoint bottomRight;

    /**
     * 轨迹字段
     */
    private String filed;

    /**
     * 实际字段
     */
    private String filed2;

    /**
     * 开始时间
     */
    private String startTime;

    /**
     * 结束时间
     */
    private String endTime;

    /**
     * 排序字段
     */
    private String sortFiled;
}
