//package cn.com.taiji.esshipservice.listener.hlx.fusion;
//
//import cn.com.taiji.esshipservice.utils.HttpsDownloadUtils;
//import com.alibaba.fastjson.JSONArray;
//import com.alibaba.fastjson.JSONObject;
//import lombok.extern.slf4j.Slf4j;
//import org.apache.kafka.clients.consumer.ConsumerRecord;
//import org.elasticsearch.action.bulk.BulkRequest;
//import org.elasticsearch.action.bulk.BulkResponse;
//import org.elasticsearch.action.index.IndexRequest;
//import org.elasticsearch.client.RequestOptions;
//import org.elasticsearch.client.RestHighLevelClient;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.kafka.annotation.KafkaListener;
//import org.springframework.kafka.annotation.TopicPartition;
//import org.springframework.kafka.support.Acknowledgment;
//import org.springframework.stereotype.Component;
//
//import java.io.IOException;
//import java.util.*;
//import java.util.concurrent.*;
//
//import static cn.com.taiji.esshipservice.constant.ShipHisTrackIndexConstants.INDEX_SEAT_HIK_CAPTURE_FACE_TRACKS;
//
//
////海康
//
///**
// * @author xhl
// */
//@Component
//@Slf4j
//public class DynamicCaptureFaceTrackConsumer {
//
//    @Autowired
//    private RestHighLevelClient client;
//
//    @Autowired
//    private HttpsDownloadUtils httpsDownloadUtils;
//
//    ExecutorService threadPool = new ThreadPoolExecutor( 10,25,10L, TimeUnit.SECONDS, new LinkedBlockingDeque<>(10), Executors.defaultThreadFactory(), new ThreadPoolExecutor.DiscardPolicy());
//
//    /**
//     * 海康人员抓拍数据-「分区」消费
//     * es场景
//     */
//
//    @KafkaListener(
//            groupId = "${taiji.kafka.consumer.groupId}",
//            topicPartitions = {
//                    @TopicPartition(
//                            topic = "${taiji.kafka.consumer.hik-capture-face.topic}",
//                            partitions = {"#{'${taiji.kafka.consumer.hik-capture-face.partitions0}'.split(',')}"}
//                    )
//            }
//    )
//    public void dynamicCaptureFaceTrack0(List<ConsumerRecord<?, ?>> records, Acknowledgment ack) {
//        threadPool.execute(()-> {
//            insertEs(records);
//        });
//        ack.acknowledge();
//    }
//
//
//    @KafkaListener(
//            groupId = "${taiji.kafka.consumer.groupId}",
//            topicPartitions = {
//                    @TopicPartition(
//                            topic = "${taiji.kafka.consumer.hik-capture-face.topic}",
//                            partitions = {"#{'${taiji.kafka.consumer.hik-capture-face.partitions1}'.split(',')}"}
//                    )
//            }
//    )
//    public void dynamicCaptureFaceTrack1(List<ConsumerRecord<?, ?>> records, Acknowledgment ack) {
//        threadPool.execute(()-> {
//            insertEs(records);
//        });
//        ack.acknowledge();
//
//    }
//
//
//    @KafkaListener(
//            groupId = "${taiji.kafka.consumer.groupId}",
//            topicPartitions = {
//                    @TopicPartition(
//                            topic = "${taiji.kafka.consumer.hik-capture-face.topic}",
//                            partitions = {"#{'${taiji.kafka.consumer.hik-capture-face.partitions2}'.split(',')}"}
//                    )
//            }
//    )
//    public void dynamicCaptureFaceTrack2(List<ConsumerRecord<?, ?>> records, Acknowledgment ack) {
//        threadPool.execute(()-> {
//            insertEs(records);
//        });
//        ack.acknowledge();
//    }
//
//
//    @KafkaListener(
//            groupId = "${taiji.kafka.consumer.groupId}",
//            topicPartitions = {
//                    @TopicPartition(
//                            topic = "${taiji.kafka.consumer.hik-capture-face.topic}",
//                            partitions = {"#{'${taiji.kafka.consumer.hik-capture-face.partitions3}'.split(',')}"}
//                    )
//            }
//    )
//    public void dynamicCaptureFaceTrack3(List<ConsumerRecord<?, ?>> records, Acknowledgment ack) {
//        threadPool.execute(()-> {
//            insertEs(records);
//        });
//        ack.acknowledge();
//    }
//
//
//    @KafkaListener(
//            groupId = "${taiji.kafka.consumer.groupId}",
//            topicPartitions = {
//                    @TopicPartition(
//                            topic = "${taiji.kafka.consumer.hik-capture-face.topic}",
//                            partitions = {"#{'${taiji.kafka.consumer.hik-capture-face.partitions4}'.split(',')}"}
//                    )
//            }
//    )
//    public void dynamicCaptureFaceTrack4(List<ConsumerRecord<?, ?>> records, Acknowledgment ack) {
//        threadPool.execute(()-> {
//            insertEs(records);
//        });
//        ack.acknowledge();
//
//    }
//
////    @Scheduled(cron = "0 30 18 * * ?")
////    public void creatIndex(){
////        threadPool.execute(()-> {
////            try {
////                TrackDaily();
////            } catch (IOException e) {
////                e.printStackTrace();
////            }
////        });
////    }
////
////    public void TrackDaily() throws IOException {
////        //获取明日零时时间
////        Calendar cal = Calendar.getInstance();
////        cal.add(Calendar.DATE,1);
////        cal.set(cal.get(Calendar.YEAR),cal.get(Calendar.MONTH),cal.get(Calendar.DAY_OF_MONTH),0,0,0);
////        Date d = cal.getTime();
////        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
////        String name = INDEX_SEAT_HIK_CAPTURE_FACE_TRACKS + sdf.format(d);
////        if (isExistsIndex(name)) {
////            return;
////        }
////        CreateIndexRequest request = new CreateIndexRequest(name);
////        // 2.准备请求参数
////        request.source(MAPPING_HIK_CAPTURE_FACE, XContentType.JSON);
////        client.indices().create(request, RequestOptions.DEFAULT);
////    }
////
////    /**
////     * 判断指定的索引名是否存在
////     *
////     * @param indexName 索引名
////     * @return 存在：true; 不存在：false;
////     */
////    public boolean isExistsIndex(String indexName) throws IOException {
////
////        GetIndexRequest getIndexRequest = new GetIndexRequest(indexName);
////        boolean flag = client.indices().exists(getIndexRequest, RequestOptions.DEFAULT);
////        return flag;
////    }
//
//    public void insertEs(List<ConsumerRecord<?, ?>> records) {
//        BulkRequest bulkRequest = new BulkRequest();
//        records.forEach(item -> {
//            Optional<?> message = Optional.ofNullable(item.value());
//            if (message.isPresent()) {
//                Object msg = message.get();
//                JSONObject map = JSONObject.parseObject(msg.toString());
//                JSONArray jsonArray = JSONObject.parseObject(map.getString("faceLibRecogList"),JSONArray.class);
//                if (jsonArray.size()>0){
//                    for (int i = 0; i < jsonArray.size(); i++) {
//                        JSONObject job = jsonArray.getJSONObject(i);
//                        Map<String, Object> maps = Collections.synchronizedMap(new HashMap<>());
//                        String id = job.getString("traceUuid")+job.getString("traceIdx");
//                        maps.put("traceUuid", job.getString("traceUuid"));
//                        maps.put("traceIdx", job.getString("traceIdx"));
//                        maps.put("cameraIndexCode", job.getString("cameraIndexCode"));
//                        maps.put("captureTime", job.getString("captureTime"));
//                        maps.put("deviceIndexCode", job.getString("deviceIndexCode"));
//                        maps.put("deviceName", job.getString("deviceName"));
////                        String bkgUrl = job.getString("bkgUrl");
////                        if (null != bkgUrl && !bkgUrl.equals("")){
////                            maps.put("bkgUrl", httpsDownloadUtils.downloadFileHttps(bkgUrl));
////                        }
//                        maps.put("bkgUrl", job.getString("bkgUrl"));
//                        maps.put("bornTime", job.getString("bornTime"));
//                        maps.put("name", job.getString("name"));
//                        maps.put("certificateNumber", job.getString("certificateNumber"));
////                        String facePicUrl = job.getString("facePicUrl");
////                        if (null != facePicUrl && !facePicUrl.equals("")){
////                            maps.put("facePicUrl", httpsDownloadUtils.downloadFileHttps(facePicUrl));
////                        }
//                        maps.put("facePicUrl",job.getString("facePicUrl"));
//                        maps.put("faceRect", job.getString("faceRect"));
//                        maps.put("linkFaceBodyId", job.getString("linkFaceBodyId"));
//                        maps.put("gender", job.getString("gender"));
//                        maps.put("genderName", job.getString("genderName"));
//                        maps.put("glass", job.getString("glass"));
//                        maps.put("glassName", job.getString("glassName"));
//                        maps.put("latitude", job.getString("latitude"));
//                        maps.put("longitude", job.getString("longitude"));
//                        maps.put("linkFaceVehicleId", job.getString("linkFaceVehicleId"));
//                        maps.put("modelData", job.getString("modelData"));
//                        maps.put("plateNo", job.getString("plateNo"));
//                        maps.put("humanId", job.getString("humanId"));
//                        maps.put("smile", job.getString("smile"));
//                        maps.put("smileName", job.getString("smileName"));
//                        maps.put("age", job.getString("age"));
//                        maps.put("ageGroup", job.getString("ageGroup"));
//                        maps.put("ageGroupName", job.getString("ageGroupName"));
//                        maps.put("rect", job.getString("rect"));
//                        maps.put("address", job.getString("address"));
//                        bulkRequest.add(new IndexRequest(INDEX_SEAT_HIK_CAPTURE_FACE_TRACKS).source(maps).id(id));
//                    }
//                }
//            }
//        });
//        try {
//            BulkResponse bulk = client.bulk(bulkRequest, RequestOptions.DEFAULT);
//        } catch (IOException e) {
//            e.printStackTrace();
//        }
//
//    }
//
//}